//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 PaleVioletRed
#property indicator_color4 PaleVioletRed
#property indicator_width3 2
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style4 STYLE_DOT

//
//
//
//
//

extern int  Sample                = 250;
extern int  Price                 = PRICE_CLOSE;
extern int  Cutoff                = 6;
extern int  Future                = 100;
extern int  RegressionDegree      = 3;
extern int  RegressionSampleSize  = 0;
extern bool RegressionLineVisible = true;

double tran[];
double futu[];
double regr[];
double regf[];
double prices[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   int style = DRAW_NONE;
      if (RegressionLineVisible) style = DRAW_LINE;
      
      //
      //
      //
      //
      //
      
      SetIndexBuffer(0,regr); SetIndexStyle(0,style);
      SetIndexBuffer(1,regf); SetIndexStyle(1,style);
      SetIndexBuffer(2,tran);
      SetIndexBuffer(3,futu);
      SetIndexBuffer(4,prices);
   return(0); 
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

#define pi 3.1415926535897932384626433832795

double a[20,20],b[20],x[20],s[40];
double work[][3];
#define _det 0
#define _rea 1
#define _ima 2

//
//
//
//
//

int start() 
{
   int i,k,n,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit     = MathMin(Bars-1,Bars-counted_bars);
         int sample    = MathMin(Bars-1,Sample);
         int cutoffEnd = MathMin(Cutoff,sample/2);
         int future    = MathMax(Future,0);
            if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--) prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
         //
         //
         //
         //
         //
         
         int rsl = MathMax(sample,RegressionSampleSize);
         int d   = RegressionDegree+1;  
            if (RegressionDegree>0)
               {
                  s[1] = rsl+1; double sum;
                    for(k=1; k<=d*2-2; k++) { sum=0; for(n=0; n<=rsl; n++) sum += MathPow(n,k); s[k+1] = sum; }
                    for(k=1; k<=d;     k++) { sum=0; for(n=0; n<=rsl; n++) sum += prices[n]*MathPow(n,k-1); b[k] = sum; }
                    for(k=1; k<=d;     k++)          for(n=1; n<=d;   n++) a[n,k]=s[k+n-1]; 
                  
                    if (!iRegr(d,a,b,x)) return(0);
                        for(i=rsl; i>=(-future); i--)
                        {
                           for(n=1,sum=0; n<d; n++) sum += x[n+1]*MathPow(i,n); 
                              if (i>=0) regr[i]        = x[1]+sum; 
                              if (i<=0) regf[i+future] = x[1]+sum; 
                         }
               }                  
            else 
               { 
                  double slope = (prices[0]-prices[rsl-1])/rsl; 
                     for(i=rsl; i>=-future; i--)
                     {
                        if (i>=0) regr[i]        = prices[0]-slope*i; 
                        if (i<=0) regf[i+future] = prices[0]-slope*i; 
                     }                     
               }

         //
         //
         //
         //
         //

         double ph = 2.0*pi/sample;
         double co = 0;
            for(i=0; i<=sample;    i++) work[Bars-i-1][_det] = prices[i]-regr[i];
            for(i=0; i<=cutoffEnd; i++)
            {
               work[Bars-i-1][_rea] = 0;
               work[Bars-i-1][_ima] = 0;
               for (k=0; k<=sample; k++)
               {
                  if (i==0) { co += work[Bars-k-1][_det]; continue; }
                     work[Bars-i-1][_rea] += work[Bars-k-1][_det]*MathCos(k*i*ph);
                     work[Bars-i-1][_ima] += work[Bars-k-1][_det]*MathSin(k*i*ph);
               }
               work[Bars-i-1][_rea] *= 2.0/sample;
               work[Bars-i-1][_ima] *= 2.0/sample;
            }
            for(i=sample; i>=-future; i--)
            {
               if (i<=0) futu[i+future] = co/sample+regf[i+future]; 
               if (i>=0) tran[i]        = co/sample+regr[i]; 
            
               //
               //
               //
               //
               //
               
               for (k=1; k<=cutoffEnd; k++)
               {
                  if (i>=0) tran[i]        += work[Bars-k-1][_rea]*MathCos(k*i*ph)+work[Bars-k-1][_ima]*MathSin(k*i*ph);
                  if (i<=0) futu[i+future] += work[Bars-k-1][_rea]*MathCos(k*i*ph)+work[Bars-k-1][_ima]*MathSin(k*i*ph);
               }                  
            }

   //
   //
   //
   //
   //
   
   SetIndexDrawBegin(0,Bars-sample+1);         
   SetIndexDrawBegin(1,Bars-future-1);         
   SetIndexDrawBegin(2,Bars-sample+1);         
   SetIndexDrawBegin(3,Bars-future-1);         
   SetIndexShift(1,future);
   SetIndexShift(3,future);
   return(0); 
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool iRegr(int n, double& a[][],double& b[], double& x[]) 
{
   int i,j,k; double t,q;

   for(k = 1; k <=n-1; k++) 
   {
      int    l = 0; 
      double m = 0; 
         for(i=k; i<=n; i++) 
            if (MathAbs(a[i,k]) > m) { m = MathAbs(a[i,k]); l = i; } 
            if (l==0) return(false);   

            //
            //
            //
            
            if(l != k) 
            {
               for(j=1; j<=n; j++) { t = a[k,j]; a[k,j] = a[l,j]; a[l,j] = t; } 
                                     t = b[k];   b[k]   = b[l];   b[l]   = t;
            }  
            for(i=k+1; i<=n; i++) 
            {
               q = a[i,k]/a[k,k]; 
                  for(j=1; j<=n; j++) 
                    if (j == k)
                           a[i,j] = 0; 
                    else   a[i,j] = a[i,j] - q*a[k,j];
               b[i] = b[i] - q*b[k];
            }
   }
   
   //
   //
   //
   //
   //
   
      x[n] = b[n] / a[n,n]; 
      for(i=n-1; i>=1; i--) 
      {
         t = 0;  
         for(j = 1; j <= n - i; j++) 
         { 
            t    += a[i,i+j]*x[i+j]; 
            x[i] = (1.0/a[i,i])*(b[i]-t);
         }
      }
   return(true);
}